## libwibble 0.1.9

=== CMakeLists.txt ===
SET( VERSION "0.1.9" )

SET( BOOST_INCLUDE_PATH
	/usr/include/boost-1_33_1/
	CACHE PATH
	"Path to the Boost include files" )
ADD_SUBDIRECTORY( wibble )

=== wibble/CMakeLists.txt ===
PROJECT( wibble )

file( GLOB WSRC_TOP *.cpp )
file( GLOB WSRC_CMDL commandline/*.cpp )
file( GLOB WSRC_SYS sys/*.cpp )
file( GLOB H_TOP *.h )
file( GLOB H_CMDL commandline/*.h )
file( GLOB H_SYS sys/*.h )
file( GLOB TCC_TOP *.tcc )

SET( WSRC ${WSRC_TOP} ${WSRC_CMDL} ${WSRC_SYS} )

set_source_files_properties( ${WSRC} COMPILE_FLAGS -fPIC )

INCLUDE_DIRECTORIES( ${wibble_SOURCE_DIR}/.. ${wibble_BINARY_DIR}/.. ${BOOST_INCLUDE_PATH} )
INSTALL_FILES( /include/wibble .h ${H_TOP} )
INSTALL_FILES( /include/wibble .tcc ${TCC_TOP} )
INSTALL_FILES( /include/wibble/commandline .h ${H_CMDL} )
INSTALL_FILES( /include/wibble/sys .h ${H_SYS} )
INSTALL_FILES( /include/wibble .h ${wibble_BINARY_DIR}/config.h )

CONFIGURE_FILE( ${wibble_SOURCE_DIR}/config.h.cmake-in
                ${wibble_BINARY_DIR}/config.h )

add_definitions( ${OPT_FLAGS} )
ADD_LIBRARY( wibble STATIC ${WSRC} )
SET_TARGET_PROPERTIES( wibble PROPERTIES DEFINE_SYMBOL WIBBLE_BUILD_FINAL )
TARGET_LINK_LIBRARIES( wibble )
INSTALL_TARGETS( /lib wibble )

ADD_SUBDIRECTORY( tests )

CONFIGURE_FILE( ${wibble_SOURCE_DIR}/libwibble.pc.cmake-in ${wibble_BINARY_DIR}/libwibble.pc @ONLY )
CONFIGURE_FILE( ${wibble_SOURCE_DIR}/libwibble-gc.pc.cmake-in ${wibble_BINARY_DIR}/libwibble-gc.pc @ONLY )
INSTALL_FILES( /lib/pkgconfig FILES libwibble.pc libwibble-gc.pc )
install_files( /share/aclocal FILES libwibble.m4 )

IF( XXX_BUILD_TESTING )
  SET( TEST_DIR ${wibble_BINARY_DIR}/tests/work/ )
  ADD_LIBRARY( wibble-testing SHARED ${WSRC} )
  SET_TARGET_PROPERTIES( wibble-testing
                         PROPERTIES DEFINE_SYMBOL WIBBLE_BUILD_TESTING )
  TARGET_LINK_LIBRARIES( wibble-testing )
ENDIF( XXX_BUILD_TESTING )

=== wibble/tests/CMakeLists.txt ===
SET( T "${CMAKE_CURRENT_SOURCE_DIR}/libwibble-check" )

file( GLOB TEST_SOURCES test_*.cpp )

ADD_CUSTOM_TARGET( check COMMAND make libwibble-test && ${T}
                   DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/data-stamp )

ADD_EXECUTABLE( libwibble-test tut-main.cpp tut-syms.cpp ${TEST_SOURCES} )
TARGET_LINK_LIBRARIES( libwibble-test wibble pthread )

ADD_EXECUTABLE( commandline-demo commandline-demo.cpp )
TARGET_LINK_LIBRARIES( commandline-demo wibble pthread )

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/data-stamp
  COMMAND touch data-stamp )

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/tut-syms.cpp
  DEPENDS ${wibble_BINARY_DIR}/libwibble.a
  COMMAND sh ${CMAKE_SOURCE_DIR}/extract_syms.sh ${wibble_BINARY_DIR}/libwibble.a wibble_sym_references > tut-syms.cpp )

=== debian/changelog ===
libwibble (0.1.9) unstable; urgency=low

  * Added sys/fs.h functions mkpath, mkFilePath, mkdirIfMissing

 -- Enrico Zini <enrico@debian.org>  Sun, 29 Oct 2006 17:34:27 +0100

libwibble (0.1.8) unstable; urgency=low

  * build-depend on libboost-dev

 -- Enrico Zini <enrico@debian.org>  Wed,  4 Oct 2006 10:01:10 +0200

libwibble (0.1.7) unstable; urgency=low

  * empty and singleton iterators now work with STL algorithms

 -- Enrico Zini <enrico@debian.org>  Sat, 30 Sep 2006 16:27:05 +0200

libwibble (0.1.6) unstable; urgency=low

  * Fixed various bugs in wibble::commandline manpage generation
  * Return size_t instead of unsigned int for empty and singleton containers,
    like the other STL classes do.

 -- Enrico Zini <enrico@debian.org>  Fri, 29 Sep 2006 22:47:42 +0200

libwibble (0.1.5) unstable; urgency=low

  * Fixed the stock commandline parsers to actually honor --help and --version
    switches

 -- Enrico Zini <enrico@debian.org>  Sun, 24 Sep 2006 00:19:00 +0100

libwibble (0.1.4) unstable; urgency=low

  * Use more efficient algorithm in wibble::operators
  * Some fixes in Mutex.h after guessnet started to use it

 -- Enrico Zini <enrico@debian.org>  Sat, 23 Sep 2006 17:44:56 +0100

libwibble (0.1.3) unstable; urgency=low

  * Allow library users to decide if they want libgc support or not
    by providing two different pkg-config files and aclocal macros

 -- Enrico Zini <enrico@debian.org>  Fri, 25 Aug 2006 12:42:49 +0100

libwibble (0.1.2) unstable; urgency=low

  * Applied patch by Andreas Jochens.  Closes: #384432.

 -- Enrico Zini <enrico@debian.org>  Thu, 24 Aug 2006 22:42:16 +0100

libwibble (0.1.1) unstable; urgency=low

  * Split tests from the rest of the .cpp code, so that they don't end up
    included in the library
  * Add linker flags for libgc to pkg-config file if support for gc is enabled

 -- Enrico Zini <enrico@debian.org>  Wed, 23 Aug 2006 23:51:22 +0100

libwibble (0.1) unstable; urgency=low

  * Initial Release.  This library is to become a dependency for tagcoll,
    apt-front, debtags, buffy, adept and possibly more.

 -- Enrico Zini <enrico@debian.org>  Wed, 16 Aug 2006 16:53:51 +0100

=== debian/control ===
Source: libwibble
Section: libdevel
Priority: optional
Maintainer: libapt-front developers <libapt-front-devel@lists.alioth.debian.org>
Uploaders: Peter Rockai <me@mornfall.net>, Enrico Zini <enrico@debian.org>
Build-Depends: cdbs, debhelper (>> 4.1), dh-buildinfo, doxygen, libtool, libboost-dev, libgc-dev, libtut-dev, cmake
Standards-Version: 3.7.2.0

Package: libwibble-dev
Section: libdevel
Tag: devel::lang:c++, devel::library, implemented-in::c++, interface::commandline, role::devel-lib
Architecture: any
Depends: libboost-dev
Recommends: pkg-config
Description: Library of various useful C++ code
 libwibble collects the foundation code that has been used over time
 in various C++ projects by Peter Rockai and Enrico Zini, so that it can
 be maintained properly and in a single place.
 .
 The library contains:
  * an exception hierarchy;
  * various useful mixin classes;
  * shortcuts for set operations;
  * a commandline parser that supports cvs-style subcommands;
  * improved macros for tut unit testing;
  * a non-intrusive polimorphic envelope.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
# comment out autotools and uncomment cmake to use cmake
#include /usr/share/cdbs/1/class/autotools.mk
include debian/cmake.mk

DEB_MAKE_CHECK_TARGET := check
# Comment out the following line to use cmake
DEB_CONFIGURE_EXTRA_FLAGS += --disable-shared --with-pic

# Store build information
common-binary-post-install-arch common-binary-post-install-indep::
	dh_buildinfo

## libwibble 0.1.10ubuntu2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-SET( VERSION "0.1.9" )
+SET( VERSION "0.1.10" )
 
 SET( BOOST_INCLUDE_PATH
 	/usr/include/boost-1_33_1/

=== wibble/CMakeLists.txt ===
--- 
+++ 
@@ -3,12 +3,16 @@
 file( GLOB WSRC_TOP *.cpp )
 file( GLOB WSRC_CMDL commandline/*.cpp )
 file( GLOB WSRC_SYS sys/*.cpp )
+file( GLOB WSRC_LOG log/*.cpp )
+file( GLOB WSRC_TEXT text/*.cpp )
 file( GLOB H_TOP *.h )
 file( GLOB H_CMDL commandline/*.h )
 file( GLOB H_SYS sys/*.h )
+file( GLOB H_LOG log/*.h )
+file( GLOB H_TEXT text/*.h )
 file( GLOB TCC_TOP *.tcc )
 
-SET( WSRC ${WSRC_TOP} ${WSRC_CMDL} ${WSRC_SYS} )
+SET( WSRC ${WSRC_TOP} ${WSRC_CMDL} ${WSRC_SYS} ${WSRC_LOG} ${WSRC_TEXT} )
 
 set_source_files_properties( ${WSRC} COMPILE_FLAGS -fPIC )
 
@@ -17,6 +21,8 @@
 INSTALL_FILES( /include/wibble .tcc ${TCC_TOP} )
 INSTALL_FILES( /include/wibble/commandline .h ${H_CMDL} )
 INSTALL_FILES( /include/wibble/sys .h ${H_SYS} )
+INSTALL_FILES( /include/wibble/log .h ${H_LOG} )
+INSTALL_FILES( /include/wibble/text .h ${H_TEXT} )
 INSTALL_FILES( /include/wibble .h ${wibble_BINARY_DIR}/config.h )
 
 CONFIGURE_FILE( ${wibble_SOURCE_DIR}/config.h.cmake-in

=== wibble/tests/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,8 @@
 ADD_EXECUTABLE( commandline-demo commandline-demo.cpp )
 TARGET_LINK_LIBRARIES( commandline-demo wibble pthread )
 
+#set_target_properties( libwibble-test PROPERTIES LINK_FLAGS ${GC_LINK_FLAGS} )
+
 ADD_CUSTOM_COMMAND(
   OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/data-stamp
   COMMAND touch data-stamp )
@@ -18,4 +20,4 @@
 ADD_CUSTOM_COMMAND(
   OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/tut-syms.cpp
   DEPENDS ${wibble_BINARY_DIR}/libwibble.a
-  COMMAND sh ${CMAKE_SOURCE_DIR}/extract_syms.sh ${wibble_BINARY_DIR}/libwibble.a wibble_sym_references > tut-syms.cpp )
+  COMMAND bash ${CMAKE_SOURCE_DIR}/extract_syms.sh ${wibble_BINARY_DIR}/libwibble.a wibble_sym_references > tut-syms.cpp )

=== debian/changelog ===
libwibble (0.1.10ubuntu2) gutsy; urgency=low

  * Fix build failures with g++-4.3.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 10 Sep 2007 14:16:15 +0200

libwibble (0.1.10ubuntu1) gutsy; urgency=low

  * Use bash to call extract_syms.sh, it's full of bashisms, and worse, was
    pulled from libtool code.
  * Munge Maintainer field as per spec.

 -- Steve Kowalik <stevenk@ubuntu.com>  Sun, 10 Jun 2007 21:26:11 +1000

libwibble (0.1.10) unstable; urgency=low

  * Added missing includes, applying tbm's patch.  Closes: #417368.
  * Added a way to see if an option was set or not.
  * Added wibble/text/wordwrap

 -- Enrico Zini <enrico@debian.org>  Thu, 24 May 2007 11:11:48 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libwibble
 Section: libdevel
 Priority: optional
-Maintainer: libapt-front developers <libapt-front-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: libapt-front developers <libapt-front-devel@lists.alioth.debian.org>
 Uploaders: Peter Rockai <me@mornfall.net>, Enrico Zini <enrico@debian.org>
 Build-Depends: cdbs, debhelper (>> 4.1), dh-buildinfo, doxygen, libtool, libboost-dev, libgc-dev, libtut-dev, cmake
 Standards-Version: 3.7.2.0

## libwibble 0.1.15

=== CMakeLists.txt ===
include( FindDoxygen )
set( VERSION "0.1.15" )
option( HAVE_TUT ON )
add_subdirectory( wibble )
add_subdirectory( doc )

=== doc/CMakeLists.txt ===
add_custom_command(
  DEPENDS wibble ${CMAKE_CURRENT_BINARY_DIR}/wibble.dox
  OUTPUT doc-stamp
  COMMAND ${DOXYGEN} wibble.dox && touch doc-stamp )

add_custom_target( doc DEPENDS doc-stamp )

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/wibble.dox.in
  ${CMAKE_CURRENT_BINARY_DIR}/wibble.dox @ONLY IMMEDIATE )

=== wibble/CMakeLists.txt ===
project( wibble )
include( test.cmake )

# glob through source files/headers
file( GLOB WSRC_TOP *.cpp )
file( GLOB WSRC_CMDL commandline/*.cpp )
file( GLOB WSRC_SYS sys/*.cpp )
file( GLOB WSRC_LOG log/*.cpp )
file( GLOB WSRC_TEXT text/*.cpp )
file( GLOB H_TOP *.h )
file( GLOB H_CMDL commandline/*.h )
file( GLOB H_SYS sys/*.h )
file( GLOB H_LOG log/*.h )
file( GLOB H_TEXT text/*.h )
file( GLOB H_TESTS tests/*.h )
file( GLOB TCC_TOP *.tcc )
file( GLOB testh *.test.h commandline/*.test.h sys/*.test.h
                 log/*.test.h text/*.test.h )

set( WSRC ${WSRC_TOP} ${WSRC_CMDL} ${WSRC_SYS} ${WSRC_LOG} ${WSRC_TEXT} )

# libwibble.a
set_source_files_properties( ${WSRC} COMPILE_FLAGS -fPIC )
include_directories( ${wibble_SOURCE_DIR}/.. ${wibble_BINARY_DIR}/.. )
add_definitions( ${OPT_FLAGS} )
add_library( wibble STATIC ${WSRC} )
target_link_libraries( wibble pthread )

# make check
wibble_add_test( wibble-test ${testh} )
target_link_libraries( wibble-test wibble )
wibble_check_target( wibble-test )

set( prefix "${CMAKE_INSTALL_PREFIX}" )
set( exec_prefix "${prefix}/bin" )
set( libdir "${prefix}/lib" )
set( includedir "${prefix}/include" )

# cmake-time configuration
configure_file( ${wibble_SOURCE_DIR}/libwibble.pc.in
                ${wibble_BINARY_DIR}/libwibble.pc @ONLY )

# make install
install( TARGETS wibble DESTINATION lib )
install( FILES ${wibble_BINARY_DIR}/libwibble.pc DESTINATION lib/pkgconfig )
install( FILES libwibble.m4 DESTINATION share/aclocal )
install( FILES wibble-test-genrunner.1 DESTINATION share/man/man1 )

install( FILES ${H_TOP} DESTINATION include/wibble )
install( FILES ${TCC_TOP} DESTINATION include/wibble )
install( FILES ${H_CMDL} DESTINATION include/wibble/commandline )
install( FILES ${H_SYS} DESTINATION include/wibble/sys )
install( FILES ${H_LOG} DESTINATION include/wibble/log )
install( FILES ${H_TEXT} DESTINATION include/wibble/text )
install( FILES ${H_TESTS} DESTINATION include/wibble/tests )
install( FILES test.cmake DESTINATION share/wibble )
install( FILES test-genrunner.pl
  RENAME wibble-test-genrunner
  DESTINATION bin
  PERMISSIONS WORLD_EXECUTE WORLD_READ )

=== debian/changelog ===
libwibble (0.1.15) unstable; urgency=low

  * Yaml parsing
  * Base64 codec
  * Path manipulations including abspath
  * Compiles with -Wall -Werror
  * Implemented repeatable options that accumulate values in a vector

 -- Enrico Zini <enrico@debian.org>  Mon, 10 Mar 2008 23:03:19 +0100

libwibble (0.1.14) unstable; urgency=low

  * Fixed a C++ error that mysteriously only shows up on ARM.
  * Fixed XS-Vcs-Darcs field

 -- Enrico Zini <enrico@debian.org>  Thu, 07 Feb 2008 10:19:29 +0000

libwibble (0.1.13) unstable; urgency=low

  * Builds with GCC 4.3.  Closes: #455630
  * Build and install Doxygen documentation.

 -- Enrico Zini <enrico@debian.org>  Wed, 30 Jan 2008 20:58:09 +0100

libwibble (0.1.12) unstable; urgency=low

  [ Enrico Zini ]
  * Split the repository in embeddable and standalone
  * Allow commandline-using programs to output a manpage just with --manpage
    and without needing --manpage=/dev/null
  * Added X-Vcs-Darcs: header
  * Added missing include.  Closes: #455630.

  [ Petr Rockai ]
  * Add a new header, wibble/sfinae.h to ease execution of SFINAE
    pattern: substitution failure is not an error (consult google),
  * change internals of Amorph to not require boost, consequently:
  * remove boost build dependency.
  * Completely new testing framework is now part of wibble.

 -- Petr Rockai <mornfall@debian.org>  Wed, 23 Jan 2008 00:12:19 +0100

libwibble (0.1.11) unstable; urgency=low

  * Added wibble::Splitter, to split strings using regexps
  * Added wibble::str::* collection of little useful string operations
  * Added missing include.  Closes: #441562.

 -- Enrico Zini <enrico@debian.org>  Mon, 17 Sep 2007 16:37:10 +0200

=== debian/control ===
Source: libwibble
Section: libdevel
Priority: optional
Maintainer: libapt-front developers <libapt-front-devel@lists.alioth.debian.org>
Uploaders: Petr Rockai <mornfall@debian.org>, Enrico Zini <enrico@debian.org>
Build-Depends: cdbs, debhelper (>> 4.1), dh-buildinfo, doxygen, cmake
Standards-Version: 3.7.3
Vcs-Darcs: http://people.debian.org/~enrico/wibble/standalone

Package: libwibble-dev
Section: libdevel
Architecture: any
Recommends: pkg-config
Description: Library of various useful C++ code
 libwibble collects the foundation code that has been used over time
 in various C++ projects by Peter Rockai and Enrico Zini, so that it can
 be maintained properly and in a single place.
 .
 The library contains:
  * an exception hierarchy;
  * various useful mixin classes;
  * shortcuts for set operations;
  * a commandline parser that supports cvs-style subcommands;
  * improved macros for tut unit testing;
  * a non-intrusive polymorphic envelope.

## libwibble 0.1.19

=== CMakeLists.txt ===
include( FindDoxygen )
set( VERSION "0.1.18" )
option( HAVE_TUT ON )
add_subdirectory( wibble )
add_subdirectory( doc )

=== debian/changelog ===
libwibble (0.1.19) unstable; urgency=low

  * Add missing constructors for some core::list classes,
  * fix some compiler warnings.

 -- Petr Rockai <mornfall@debian.org>  Tue, 17 Jun 2008 23:05:58 +0200

libwibble (0.1.18) unstable; urgency=low

  * Added versioned dependency on CDBS.  Closes: #486590.

 -- Enrico Zini <enrico@debian.org>  Tue, 17 Jun 2008 12:37:08 +0100

libwibble (0.1.17) unstable; urgency=low

  [ Enrico Zini ]
  * Fixes for OS X,
  * simplistic mmap support,
  * PosixBuf,
  * allow to use Splitter with STL algorithms,
  * bugfixes.

  [ Petr Rockai ]
  * Get back setValue for options in commandline parser,
  * added TPair to wibble/sfinae.h,
  * include a generic list utility library,
  * implement simple formatting (str::fmt) of sets and lists,
  * a new assert implementation,
  * fix a bug in build system that caused FTBFS with cmake 2.6
    (closes: #482246).

 -- Petr Rockai <mornfall@debian.org>  Mon, 26 May 2008 23:24:47 +0200

libwibble (0.1.16) unstable; urgency=low

  * Added missing commandline::ExistingFile::toString

 -- Enrico Zini <enrico@debian.org>  Fri, 28 Mar 2008 10:16:57 +0800

## libwibble 0.1.22

=== CMakeLists.txt ===
include( FindDoxygen )
set( VERSION "0.1.22" )
option( HAVE_TUT ON )
add_subdirectory( wibble )
add_subdirectory( doc )

=== wibble/CMakeLists.txt ===
--- 
+++ 
@@ -7,17 +7,21 @@
 file( GLOB WSRC_SYS sys/*.cpp )
 file( GLOB WSRC_LOG log/*.cpp )
 file( GLOB WSRC_TEXT text/*.cpp )
+file( GLOB WSRC_GRCAL grcal/*.cpp )
+file( GLOB WSRC_STREAM stream/*.cpp )
 file( GLOB H_TOP *.h )
 file( GLOB H_CMDL commandline/*.h )
 file( GLOB H_SYS sys/*.h )
 file( GLOB H_LOG log/*.h )
 file( GLOB H_TEXT text/*.h )
+file( GLOB H_GRCAL grcal/*.h )
+file( GLOB H_STREAM stream/*.h )
 file( GLOB H_TESTS tests/*.h )
 file( GLOB TCC_TOP *.tcc )
 file( GLOB testh *.test.h commandline/*.test.h sys/*.test.h
-                 log/*.test.h text/*.test.h )
+                 log/*.test.h text/*.test.h grcal/*.test.h stream/*.test.h )
 
-set( WSRC ${WSRC_TOP} ${WSRC_CMDL} ${WSRC_SYS} ${WSRC_LOG} ${WSRC_TEXT} )
+set( WSRC ${WSRC_TOP} ${WSRC_CMDL} ${WSRC_SYS} ${WSRC_LOG} ${WSRC_TEXT} ${WSRC_GRCAL} ${WSRC_STREAM})
 
 # libwibble.a
 set_source_files_properties( ${WSRC} COMPILE_FLAGS -fPIC )
@@ -52,6 +56,8 @@
 install( FILES ${H_SYS} DESTINATION include/wibble/sys )
 install( FILES ${H_LOG} DESTINATION include/wibble/log )
 install( FILES ${H_TEXT} DESTINATION include/wibble/text )
+install( FILES ${H_GRCAL} DESTINATION include/wibble/grcal )
+install( FILES ${H_STREAM} DESTINATION include/wibble/stream )
 install( FILES ${H_TESTS} DESTINATION include/wibble/tests )
 install( FILES test.cmake DESTINATION share/wibble )
 install( FILES test-genrunner.pl

=== debian/changelog ===
libwibble (0.1.22) unstable; urgency=low

  * Avoid double free corruption in cases where wibble is linked into both
    executable and a shared library it uses (doubly called static
    destructor),
  * add sys::ChildProcess::waitForSuccess(),
  * fix some compiler warnings.

 -- Petr Rockai <mornfall@debian.org>  Sun, 17 Aug 2008 12:15:51 +0200

libwibble (0.1.21) experimental; urgency=low

  * Make list::map work on non-default-constructible functors,
  * add list::output( list, output_iterator ),
  * change the exception formatting to span multiple lines (more readable
    with bigger contexts),
  * implement str::fmt for vectors.

 -- Petr Rockai <mornfall@debian.org>  Tue, 05 Aug 2008 19:43:04 +0200

libwibble (0.1.20) experimental; urgency=low

  * Add std::string str::fmt(std::string, ...) - asprintf style,
  * provide sys::ChildProcess::running() predicate,
  * fix a bunch of compiler warnings.

 -- Petr Rockai <mornfall@debian.org>  Thu, 31 Jul 2008 13:45:52 +0200

=== debian/control ===
Source: libwibble
Section: libdevel
Priority: optional
Maintainer: libapt-front developers <libapt-front-devel@lists.alioth.debian.org>
Uploaders: Petr Rockai <mornfall@debian.org>, Enrico Zini <enrico@debian.org>
Build-Depends: cdbs (>= 0.4.51), debhelper (>> 4.1), dh-buildinfo, doxygen, cmake
Standards-Version: 3.7.3
Vcs-Darcs: http://people.debian.org/~enrico/wibble/standalone

Package: libwibble-dev
Section: libdevel
Architecture: any
Recommends: pkg-config
Description: Library of various useful C++ code
 libwibble collects the foundation code that has been used over time
 in various C++ projects by Peter Rockai and Enrico Zini, so that it can
 be maintained properly and in a single place.
 .
 The code has minimal dependencies, a test suite, and can be used either as an
 external library or embedded in projects based on either cmake or autotools.
 .
 The library contains:
  * an exception hierarchy;
  * various useful mixin classes;
  * shortcuts for set operations;
  * a featureful self-documenting commandline parser that also supports
    cvs/svn-style subcommands;
  * two different unit-testing system, a tut-based and a custom one;
  * a non-intrusive polymorphic envelope;
  * a logging system;
  * string functions, like splitting, path manipulation, regular
    expressions and word wrapping;
  * system functions, like directory iteration, file manipulation, process
    control, thread functions;
  * gregorian calendar operations.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

# TODO workaround for cmake breakage; debian bug #459207
CC = /usr/bin/gcc
CXX = /usr/bin/g++

DEB_MAKE_CHECK_TARGET := check
# Comment out the following line to use cmake
#DEB_CONFIGURE_EXTRA_FLAGS += --disable-shared --with-pic

# Store build information
common-binary-post-install-arch common-binary-post-install-indep::
	dh_buildinfo

build/libwibble-dev::
	make -C ${DEB_BUILDDIR} doc

# I'd like to use debian/libwibble-dev.docs, but I have to invoke
# dh_installdocs here since the name of the build directory changes every time.
binary-install/libwibble-dev::
	dh_installdocs -p$(cdbs_curpkg) -n ${DEB_BUILDDIR}/doc/html

## libwibble 0.1.22ubuntu1

=== debian/changelog ===
libwibble (0.1.22ubuntu1) karmic; urgency=low

  * wibble/string.h:
    - Fix gcc-4.4 FTBFS by including <cstdio> (LP: #385317)

 -- Michael Terry <michael.terry@canonical.com>  Wed, 10 Jun 2009 09:33:30 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libwibble
 Section: libdevel
 Priority: optional
-Maintainer: libapt-front developers <libapt-front-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: libapt-front developers <libapt-front-devel@lists.alioth.debian.org>
 Uploaders: Petr Rockai <mornfall@debian.org>, Enrico Zini <enrico@debian.org>
 Build-Depends: cdbs (>= 0.4.51), debhelper (>> 4.1), dh-buildinfo, doxygen, cmake
 Standards-Version: 3.7.3

## libwibble 0.1.24

=== CMakeLists.txt ===
include( FindDoxygen )
set( VERSION "0.1.24" )
option( HAVE_TUT ON )
add_custom_target( unit )
add_subdirectory( wibble )
add_subdirectory( doc )

## libwibble 0.1.26

=== CMakeLists.txt ===
include( FindDoxygen )
set( VERSION "0.1.26" )
option( HAVE_TUT ON )
add_custom_target( unit )
add_subdirectory( wibble )
add_subdirectory( doc )

=== wibble/CMakeLists.txt ===
--- 
+++ 
@@ -23,17 +23,31 @@
 
 set( WSRC ${WSRC_TOP} ${WSRC_CMDL} ${WSRC_SYS} ${WSRC_LOG} ${WSRC_TEXT} ${WSRC_GRCAL} ${WSRC_STREAM})
 
+# on some mingw32, regex.h is not on the default include path
+find_path( RX_PATH regex.h )
+include_directories( ${RX_PATH} )
+
 # libwibble.a
+if( NOT WINDOWS )
 set_source_files_properties( ${WSRC} COMPILE_FLAGS -fPIC )
+endif( NOT WINDOWS )
+
 include_directories( ${wibble_SOURCE_DIR}/.. ${wibble_BINARY_DIR}/.. )
 add_definitions( ${OPT_FLAGS} )
 add_library( wibble STATIC ${WSRC} )
+
+if( WINDOWS )
+target_link_libraries( wibble wsock32 psapi regex )
+else( WINDOWS )
 target_link_libraries( wibble pthread )
+endif( WINDOWS )
 
+if( NOT WINDOWS )
 # make check
 wibble_add_test( wibble-test ${testh} )
 target_link_libraries( wibble-test wibble )
 wibble_check_target( wibble-test )
+endif( NOT WINDOWS )
 
 set( prefix "${CMAKE_INSTALL_PREFIX}" )
 set( exec_prefix "${prefix}/bin" )

## libwibble 0.1.28

=== CMakeLists.txt ===
include( FindDoxygen )
set( VERSION "0.1.28" )
option( HAVE_TUT ON )
add_custom_target( unit )
add_subdirectory( wibble )
add_subdirectory( doc )

=== wibble/CMakeLists.txt ===
project( wibble )
include( test.cmake )

include( CheckCXXSourceCompiles )
check_cxx_source_compiles(
 "#include <dirent.h>
  int main() {
      struct dirent *d;
      (void)d->d_type;
      return 0;
  }" HAVE_STRUCT_DIRENT_D_TYPE )

configure_file( ${wibble_SOURCE_DIR}/config.h.cmake-in ${wibble_BINARY_DIR}/config.h )
add_definitions( -DHAVE_CONFIG_H )

# glob through source files/headers
file( GLOB WSRC_TOP *.cpp )
file( GLOB WSRC_CMDL commandline/*.cpp )
file( GLOB WSRC_SYS sys/*.cpp )
file( GLOB WSRC_LOG log/*.cpp )
file( GLOB WSRC_TEXT text/*.cpp )
file( GLOB WSRC_GRCAL grcal/*.cpp )
file( GLOB WSRC_STREAM stream/*.cpp )
file( GLOB WSRC_NET net/*.cpp )
file( GLOB H_TOP *.h )
file( GLOB H_CMDL commandline/*.h )
file( GLOB H_SYS sys/*.h )
file( GLOB H_LOG log/*.h )
file( GLOB H_TEXT text/*.h )
file( GLOB H_GRCAL grcal/*.h )
file( GLOB H_STREAM stream/*.h )
file( GLOB H_NET net/*.h )
file( GLOB H_TESTS tests/*.h )
file( GLOB TCC_TOP *.tcc )
file( GLOB testh *.test.h commandline/*.test.h sys/*.test.h
                 log/*.test.h text/*.test.h grcal/*.test.h stream/*.test.h net/*.test.h )

set( WSRC ${WSRC_TOP} ${WSRC_CMDL} ${WSRC_SYS} ${WSRC_LOG} ${WSRC_TEXT} ${WSRC_GRCAL} ${WSRC_STREAM} ${WSRC_NET})

# on some mingw32, regex.h is not on the default include path
find_path( RX_PATH regex.h )
include_directories( ${RX_PATH} )

# libwibble.a
if( NOT WIN32 )
set_source_files_properties( ${WSRC} COMPILE_FLAGS -fPIC )
endif( NOT WIN32 )

include_directories( ${wibble_SOURCE_DIR}/.. ${wibble_BINARY_DIR}/.. )
add_definitions( ${OPT_FLAGS} )
add_library( wibble STATIC ${WSRC} )

if( WIN32 )
target_link_libraries( wibble wsock32 psapi regex )
else( WIN32 )
target_link_libraries( wibble pthread )
endif( WIN32 )

if( NOT WIN32 )
# make check
wibble_add_test( wibble-test ${testh} )
target_link_libraries( wibble-test wibble )
wibble_check_target( wibble-test )
endif( NOT WIN32 )

set( prefix "${CMAKE_INSTALL_PREFIX}" )
set( exec_prefix "${prefix}/bin" )
set( libdir "${prefix}/lib" )
set( includedir "${prefix}/include" )

# cmake-time configuration
configure_file( ${wibble_SOURCE_DIR}/libwibble.pc.in
                ${wibble_BINARY_DIR}/libwibble.pc @ONLY )

# make install
install( TARGETS wibble DESTINATION lib COMPONENT wibble_dev )

if( NOT WIN32 )
install( FILES ${wibble_BINARY_DIR}/libwibble.pc DESTINATION lib/pkgconfig COMPONENT wibble_dev )
install( FILES libwibble.m4 DESTINATION share/aclocal COMPONENT wibble_dev )
install( FILES wibble-test-genrunner.1 DESTINATION share/man/man1 COMPONENT wibble_dev )
endif( NOT WIN32 )

install( FILES ${H_TOP} DESTINATION include/wibble COMPONENT wibble_dev )
install( FILES ${TCC_TOP} DESTINATION include/wibble COMPONENT wibble_dev )
install( FILES ${H_CMDL} DESTINATION include/wibble/commandline COMPONENT wibble_dev )
install( FILES ${H_SYS} DESTINATION include/wibble/sys COMPONENT wibble_dev )
install( FILES ${H_LOG} DESTINATION include/wibble/log COMPONENT wibble_dev )
install( FILES ${H_TEXT} DESTINATION include/wibble/text COMPONENT wibble_dev )
install( FILES ${H_GRCAL} DESTINATION include/wibble/grcal COMPONENT wibble_dev )
install( FILES ${H_STREAM} DESTINATION include/wibble/stream COMPONENT wibble_dev )
install( FILES ${H_NET} DESTINATION include/wibble/net COMPONENT wibble_dev )
install( FILES ${H_TESTS} DESTINATION include/wibble/tests COMPONENT wibble_dev )

if( NOT WIN32 )
install( FILES test.cmake DESTINATION share/wibble COMPONENT wibble_dev )
install( FILES test-genrunner.pl
  RENAME wibble-test-genrunner
  DESTINATION bin COMPONENT wibble_dev 
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE )
endif( NOT WIN32 )

## libwibble 1.1

=== CMakeLists.txt ===
include( FindDoxygen )
set( VERSION "1.1" )
option( HAVE_TUT ON )
if( NOT WIN32 )
    add_definitions( -DPOSIX )
endif()
add_custom_target( unit )
add_subdirectory( wibble )
add_subdirectory( doc )

=== doc/CMakeLists.txt ===
set( stamp "${CMAKE_CURRENT_BINARY_DIR}/doc-stamp" )
add_custom_command(
  DEPENDS wibble ${CMAKE_CURRENT_BINARY_DIR}/wibble.dox
  OUTPUT ${stamp}
  COMMAND ${DOXYGEN} wibble.dox && touch ${stamp} )

add_custom_target( doc DEPENDS ${stamp} )

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/wibble.dox.in
  ${CMAKE_CURRENT_BINARY_DIR}/wibble.dox @ONLY IMMEDIATE )

=== wibble/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
   }" HAVE_STRUCT_DIRENT_D_TYPE )
 
 configure_file( ${wibble_SOURCE_DIR}/config.h.cmake-in ${wibble_BINARY_DIR}/config.h )
-add_definitions( -DHAVE_CONFIG_H )
+add_definitions( -DHAVE_CONFIG_H -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 )
 
 # glob through source files/headers
 file( GLOB WSRC_TOP *.cpp )
@@ -39,7 +39,9 @@
 
 # on some mingw32, regex.h is not on the default include path
 find_path( RX_PATH regex.h )
-include_directories( ${RX_PATH} )
+if( RX_PATH )
+  include_directories( ${RX_PATH} )
+endif()
 
 # libwibble.a
 if( NOT WIN32 )
@@ -56,16 +58,16 @@
 target_link_libraries( wibble pthread )
 endif( WIN32 )
 
-if( NOT WIN32 )
 # make check
 wibble_add_test( wibble-test ${testh} )
 target_link_libraries( wibble-test wibble )
 wibble_check_target( wibble-test )
-endif( NOT WIN32 )
 
 set( prefix "${CMAKE_INSTALL_PREFIX}" )
 set( exec_prefix "${prefix}/bin" )
-set( libdir "${prefix}/lib" )
+if (NOT DEFINED libdir)
+	set( libdir "${prefix}/lib" )
+endif()
 set( includedir "${prefix}/include" )
 
 # cmake-time configuration
@@ -73,10 +75,10 @@
                 ${wibble_BINARY_DIR}/libwibble.pc @ONLY )
 
 # make install
-install( TARGETS wibble DESTINATION lib COMPONENT wibble_dev )
+install( TARGETS wibble DESTINATION lib/${CMAKE_LIBRARY_ARCHITECTURE} COMPONENT wibble_dev )
 
 if( NOT WIN32 )
-install( FILES ${wibble_BINARY_DIR}/libwibble.pc DESTINATION lib/pkgconfig COMPONENT wibble_dev )
+install( FILES ${wibble_BINARY_DIR}/libwibble.pc DESTINATION lib/${CMAKE_LIBRARY_ARCHITECTURE}/pkgconfig COMPONENT wibble_dev )
 install( FILES libwibble.m4 DESTINATION share/aclocal COMPONENT wibble_dev )
 install( FILES wibble-test-genrunner.1 DESTINATION share/man/man1 COMPONENT wibble_dev )
 endif( NOT WIN32 )

=== wibble/tests/CMakeLists.txt ===
SET( T sh ${CMAKE_CURRENT_SOURCE_DIR}/libwibble-check )

file( GLOB TEST_SOURCES test_*.cpp )

ADD_CUSTOM_TARGET( check COMMAND make libwibble-test && ${T}
                   DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/data-stamp )

ADD_EXECUTABLE( libwibble-test tut-main.cpp ${TEST_SOURCES} )
TARGET_LINK_LIBRARIES( libwibble-test wibble pthread )

ADD_EXECUTABLE( commandline-demo commandline-demo.cpp )
TARGET_LINK_LIBRARIES( commandline-demo wibble pthread )

#set_target_properties( libwibble-test PROPERTIES LINK_FLAGS ${GC_LINK_FLAGS} )

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/data-stamp
  COMMAND touch data-stamp )

#ADD_CUSTOM_COMMAND(
#  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/tut-syms.cpp
#  DEPENDS ${wibble_BINARY_DIR}/libwibble.a
#  COMMAND sh ${CMAKE_SOURCE_DIR}/extract_syms.sh ${wibble_BINARY_DIR}/libwibble.a wibble_sym_references > tut-syms.cpp )

=== debian/changelog ===
libwibble (1.1-2) unstable; urgency=medium

  * QA upload.
  * Set maintainer to QA group. (See: #813208, Closes: #869342)
  * Remove Vcs-Darcs and Homepage fields, both are no
    longer available. (Closes: #861673)
  * Remove tarball and darcs targets from debian/rules because of no
    longer existing darcs service.
  * Convert to source format 3.0 (quilt).
  * Honour SOURCE_DATE_EPOCH for date in generated manpages.
    Thanks to Chris Lamb for the patch (Closes: #861672)
  * Bump debhelper compatibility to 10.
  * Bump Standards-Version to 4.1.0.
  * Clean doxygen cruft with dh_doxygen.
  * Register documentation at doc-base.
  * Mark libwibble-dev as Multi-Arch: same.
  * Remove unneeded libwibble.dirs file.
  * Drop use of dh-buildinfo as .buildinfo files are also generated by
    dpkg-genbuildinfo.
  * Add lintian override for embedded-javascript-library caused by
    jquery.js from doxygen.
  * Do not run the tests when DEB_BUILD_OPTIONS=nocheck is set.
    This fixes cross build of libwibble. (Closes: #718618)

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 19 Sep 2017 17:43:54 +0200

libwibble (1.1-1) unstable; urgency=low

  * New upstream version
     - Reimplemented Directory so it can be iterated twice
     - Added new sys::fs functions

 -- Enrico Zini <enrico@debian.org>  Wed, 23 Oct 2013 11:55:11 +0200

libwibble (1.0-1) unstable; urgency=low

  * New upstream version
     - fixed mkdirIfMissing for freebsd
     - use proper (insane) struct direct allocation to make it portable
     - skip file locking in file logger for hurd, which doesn't support
       F_SETLK
     - bumped release to 1.0

 -- Enrico Zini <enrico@debian.org>  Mon, 21 Oct 2013 17:12:39 +0200

libwibble (0.2.3-1) unstable; urgency=low

  * New upstream version
     - reverted an accidental API-incompatible change in sys::fs::stat
     - use flock instead of flock64, which is missing on hurd and should do
       the right thing

 -- Enrico Zini <enrico@debian.org>  Sun, 20 Oct 2013 23:36:36 +0200

libwibble (0.2.2-1) unstable; urgency=low

  * New upstream version
     - fixed uninitialized Option::hidden, which caused options to randomly
       disappear from command line help
     - sys/thread.h: #include <unistd.h> so that sleep and usleep are defined
     - added new test infrastructure, with backtraces, exception catching and
       the possibility of setting context information, for example the
       iteration number for tests run in a loop
     - parse.h: added a framework for writing backtracking recursive-descent
       parsers
     - sys/pipe.h: added PipeThrough to run data through a filter child
       process
     - [c++11-only]: added RAII helpers
     - [c++11-only]: added StrongEnumFlags
     - [c++11-only]: added a new MMap interface
  * Ported to debhelper 7

 -- Enrico Zini <enrico@debian.org>  Sun, 20 Oct 2013 20:09:50 +0200

libwibble (0.2.0-1) unstable; urgency=low

  * New upstream version
     - API has changed!
     - API is now independent of _FILE_OFFSET_BITS on 32bit systems
     - Removed deprecated functions sys::fs::isDirectory and printf-style
       str::fmt
     - sys::fs::Directory has been mostly rewritten with a cleaner interface

 -- Enrico Zini <enrico@debian.org>  Thu, 11 Aug 2011 16:39:14 +0200

libwibble (0.1.28-1) unstable; urgency=low

  * New upstream version
     - Added a missing include. Thanks Ilya Barygin for the patch.
       Closes: #625046
  * Changed maintainer to myself, list has been closed
  * Updated standards-version, no changes required

 -- Enrico Zini <enrico@debian.org>  Wed, 20 Jul 2011 12:59:57 +0200

libwibble (0.1.27-1) unstable; urgency=low

  * New upstream version
     - Various fixes and several functions added, especially a TCP
       server, MIME parsing code and an HTTP server implementation

 -- Enrico Zini <enrico@debian.org>  Sun, 13 Feb 2011 18:27:27 +0000

libwibble (0.1.26-1) unstable; urgency=low

  * Make process::getcwd() work on freebsd. Thanks to Pino Toscano.

 -- Enrico Zini <enrico@debian.org>  Tue, 11 May 2010 13:41:43 +0100

libwibble (0.1.25-1) unstable; urgency=low

  * New upstream version
     - Disallow copy of Mutex and Condition objects

 -- Enrico Zini <enrico@debian.org>  Sun, 28 Feb 2010 13:00:44 +0000

libwibble (0.1.24-1) unstable; urgency=low

  * Disabled tests that fail on HPPA until mornfall will manage to
    investigate. Closes: #561187.

 -- Enrico Zini <enrico@debian.org>  Tue, 15 Dec 2009 17:36:34 +0000

libwibble (0.1.23-1) unstable; urgency=low

  * New upstream version
     + Add wibble::sys
     + Improvement in Mutex
     + Lockfile support
     + Added missing include. Closes: #504896
     + Added today and now to grcal
     + Deprecate str::fmt(format, args...) in favour of str::fmtf
  * Switch to non-native packaging
  * Updated standards-version
  * Updated Vcs-Darcs location
  * Added Homepage field

 -- Enrico Zini <enrico@debian.org>  Mon, 14 Dec 2009 13:24:26 +0000

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,14 @@
 Source: libwibble
 Section: libdevel
 Priority: optional
-Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: libapt-front developers <libapt-front-devel@lists.alioth.debian.org>
-Uploaders: Petr Rockai <mornfall@debian.org>, Enrico Zini <enrico@debian.org>
-Build-Depends: cdbs (>= 0.4.51), debhelper (>> 4.1), dh-buildinfo, doxygen, cmake
-Standards-Version: 3.7.3
-Vcs-Darcs: http://people.debian.org/~enrico/wibble/standalone
+Maintainer: Debian QA Group <packages@qa.debian.org>
+Build-Depends: debhelper (>= 10), doxygen, cmake
+Standards-Version: 4.1.0
 
 Package: libwibble-dev
-Section: libdevel
 Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends}
 Recommends: pkg-config
 Description: Library of various useful C++ code
  libwibble collects the foundation code that has been used over time

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR = $(CURDIR)/debian/build

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR)

override_dh_auto_build:
	dh_auto_build
	make -C $(BUILDDIR) doc

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	make -C $(BUILDDIR) unit
endif

override_dh_auto_install:
	dh_auto_install
	dh_installdocs -plibwibble-dev -n $(BUILDDIR)/doc/html
	dh_doxygen
